org.keycloak.models.cache

## Class DefaultCacheUserProvider

- java.lang.Object
- - org.keycloak.models.cache.DefaultCacheUserProvider

- All Implemented Interfaces:
    CacheUserProvider, UserProvider, Provider

      public class DefaultCacheUserProvider
      extends Object
      implements CacheUserProvider

  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected UserCache` | `cache`
    `protected boolean` | `clearAll`
    `protected UserProvider` | `delegate`
    `protected Map<String,UserModel>` | `managedUsers`
    `protected Set<String>` | `realmInvalidations`
    `protected KeycloakSession` | `session`
    `protected boolean` | `setRollbackOnly`
    `protected boolean` | `transactionActive`
    `protected Map<String,String>` | `userInvalidations`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultCacheUserProvider(UserCache cache, KeycloakSession session)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addSocialLink(RealmModel realm, UserModel user, SocialLinkModel socialLink)`
    `UserModel` | `addUser(RealmModel realm, String username)`
    `UserModel` | `addUser(RealmModel realm, String id, String username, boolean addDefaultRoles)`
    `void` | `close()`
    `UserProvider` | `getDelegate()`
    `SocialLinkModel` | `getSocialLink(UserModel user, String socialProvider, RealmModel realm)`
    `Set<SocialLinkModel>` | `getSocialLinks(UserModel user, RealmModel realm)`
    `UserModel` | `getUserByEmail(String email, RealmModel realm)`
    `UserModel` | `getUserById(String id, RealmModel realm)`
    `UserModel` | `getUserBySocialLink(SocialLinkModel socialLink, RealmModel realm)`
    `UserModel` | `getUserByUsername(String username, RealmModel realm)`
    `List<UserModel>` | `getUsers(RealmModel realm)`
    `List<UserModel>` | `getUsers(RealmModel realm, int firstResult, int maxResults)`
    `int` | `getUsersCount(RealmModel realm)`
    `boolean` | `isEnabled()`
    `void` | `preRemove(RealmModel realm)`
    `void` | `preRemove(RealmModel realm, RoleModel role)`
    `void` | `preRemove(RealmModel realm, UserFederationProviderModel link)`
    `void` | `registerUserInvalidation(RealmModel realm, String id)`
    `boolean` | `removeSocialLink(RealmModel realm, UserModel user, String socialProvider)`
    `boolean` | `removeUser(RealmModel realm, UserModel user)`
    `protected void` | `runInvalidations()`
    `List<UserModel>` | `searchForUser(String search, RealmModel realm)`
    `List<UserModel>` | `searchForUser(String search, RealmModel realm, int firstResult, int maxResults)`
    `List<UserModel>` | `searchForUserByAttributes(Map<String,String> attributes, RealmModel realm)`
    `List<UserModel>` | `searchForUserByAttributes(Map<String,String> attributes, RealmModel realm, int firstResult, int maxResults)`
    `void` | `setEnabled(boolean enabled)`
    `boolean` | `validCredentials(RealmModel realm, UserModel user, List<UserCredentialModel> input)`
    `boolean` | `validCredentials(RealmModel realm, UserModel user, UserCredentialModel... input)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### cache

          protected UserCache cache

    - #### session

          protected KeycloakSession session

    - #### delegate

          protected UserProvider delegate

    - #### transactionActive

          protected boolean transactionActive

    - #### setRollbackOnly

          protected boolean setRollbackOnly

    - #### userInvalidations

          protected Map<String,String> userInvalidations

    - #### realmInvalidations

          protected Set<String> realmInvalidations

    - #### managedUsers

          protected Map<String,UserModel> managedUsers

    - #### clearAll

          protected boolean clearAll

  - ### Constructor Detail

    - #### DefaultCacheUserProvider

          public DefaultCacheUserProvider(UserCache cache,
                                  KeycloakSession session)

  - ### Method Detail

    - #### isEnabled

          public boolean isEnabled()

      Specified by:
        `isEnabled` in interface `CacheUserProvider`

    - #### setEnabled

          public void setEnabled(boolean enabled)

      Specified by:
        `setEnabled` in interface `CacheUserProvider`

    - #### getDelegate

          public UserProvider getDelegate()

      Specified by:
        `getDelegate` in interface `CacheUserProvider`

    - #### registerUserInvalidation

          public void registerUserInvalidation(RealmModel realm,
                                      String id)

      Specified by:
        `registerUserInvalidation` in interface `CacheUserProvider`

    - #### runInvalidations

          protected void runInvalidations()

    - #### getUserById

          public UserModel getUserById(String id,
                              RealmModel realm)

      Specified by:
        `getUserById` in interface `UserProvider`

    - #### getUserByUsername

          public UserModel getUserByUsername(String username,
                                    RealmModel realm)

      Specified by:
        `getUserByUsername` in interface `UserProvider`

    - #### getUserByEmail

          public UserModel getUserByEmail(String email,
                                 RealmModel realm)

      Specified by:
        `getUserByEmail` in interface `UserProvider`

    - #### close

          public void close()

      Specified by:
        `close` in interface `UserProvider`
      Specified by:
        `close` in interface `Provider`

    - #### getUserBySocialLink

          public UserModel getUserBySocialLink(SocialLinkModel socialLink,
                                      RealmModel realm)

      Specified by:
        `getUserBySocialLink` in interface `UserProvider`

    - #### getUsers

          public List<UserModel> getUsers(RealmModel realm)

      Specified by:
        `getUsers` in interface `UserProvider`

    - #### getUsersCount

          public int getUsersCount(RealmModel realm)

      Specified by:
        `getUsersCount` in interface `UserProvider`

    - #### getUsers

          public List<UserModel> getUsers(RealmModel realm,
                                 int firstResult,
                                 int maxResults)

      Specified by:
        `getUsers` in interface `UserProvider`

    - #### searchForUser

          public List<UserModel> searchForUser(String search,
                                      RealmModel realm)

      Specified by:
        `searchForUser` in interface `UserProvider`

    - #### searchForUser

          public List<UserModel> searchForUser(String search,
                                      RealmModel realm,
                                      int firstResult,
                                      int maxResults)

      Specified by:
        `searchForUser` in interface `UserProvider`

    - #### searchForUserByAttributes

          public List<UserModel> searchForUserByAttributes(Map<String,String> attributes,
                                                  RealmModel realm)

      Specified by:
        `searchForUserByAttributes` in interface `UserProvider`

    - #### searchForUserByAttributes

          public List<UserModel> searchForUserByAttributes(Map<String,String> attributes,
                                                  RealmModel realm,
                                                  int firstResult,
                                                  int maxResults)

      Specified by:
        `searchForUserByAttributes` in interface `UserProvider`

    - #### getSocialLinks

          public Set<SocialLinkModel> getSocialLinks(UserModel user,
                                            RealmModel realm)

      Specified by:
        `getSocialLinks` in interface `UserProvider`

    - #### getSocialLink

          public SocialLinkModel getSocialLink(UserModel user,
                                      String socialProvider,
                                      RealmModel realm)

      Specified by:
        `getSocialLink` in interface `UserProvider`

    - #### addUser

          public UserModel addUser(RealmModel realm,
                          String id,
                          String username,
                          boolean addDefaultRoles)

      Specified by:
        `addUser` in interface `UserProvider`

    - #### addUser

          public UserModel addUser(RealmModel realm,
                          String username)

      Specified by:
        `addUser` in interface `UserProvider`

    - #### removeUser

          public boolean removeUser(RealmModel realm,
                           UserModel user)

      Specified by:
        `removeUser` in interface `UserProvider`

    - #### addSocialLink

          public void addSocialLink(RealmModel realm,
                           UserModel user,
                           SocialLinkModel socialLink)

      Specified by:
        `addSocialLink` in interface `UserProvider`

    - #### removeSocialLink

          public boolean removeSocialLink(RealmModel realm,
                                 UserModel user,
                                 String socialProvider)

      Specified by:
        `removeSocialLink` in interface `UserProvider`

    - #### validCredentials

          public boolean validCredentials(RealmModel realm,
                                 UserModel user,
                                 List<UserCredentialModel> input)

      Specified by:
        `validCredentials` in interface `UserProvider`

    - #### validCredentials

          public boolean validCredentials(RealmModel realm,
                                 UserModel user,
                                 UserCredentialModel... input)

      Specified by:
        `validCredentials` in interface `UserProvider`

    - #### preRemove

          public void preRemove(RealmModel realm)

      Specified by:
        `preRemove` in interface `UserProvider`

    - #### preRemove

          public void preRemove(RealmModel realm,
                       RoleModel role)

      Specified by:
        `preRemove` in interface `UserProvider`

    - #### preRemove

          public void preRemove(RealmModel realm,
                       UserFederationProviderModel link)

      Specified by:
        `preRemove` in interface `UserProvider`

Copyright © 2014. All Rights Reserved.